> ## Documentation Index
> Fetch the complete documentation index at: https://docs.honeyhive.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Create a new datapoint



## OpenAPI

````yaml post /datapoints
openapi: 3.0.3
info:
  title: HoneyHive API
  version: 1.0.1
servers:
  - url: https://api.honeyhive.ai
security:
  - BearerAuth: []
paths:
  /datapoints:
    post:
      tags:
        - Datapoints
      summary: Create a new datapoint
      operationId: createDatapoint
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CreateDatapointRequest'
      responses:
        '200':
          description: Datapoint successfully created
          content:
            application/json:
              schema:
                type: object
                properties:
                  result:
                    type: object
                    properties:
                      insertedId:
                        type: string
      x-codeSamples:
        - lang: python
          label: createDatapoint
          source: >-
            import honeyhive

            from honeyhive.models import components


            s = honeyhive.HoneyHive(
                bearer_auth="<YOUR_BEARER_TOKEN_HERE>",
            )



            res =
            s.datapoints.create_datapoint(request=components.CreateDatapointRequest(
                project='New Project',
                inputs={
                    'query': 'what\'s the temperature in Iceland?',
                },
                history=[
                    {
                        'role': 'system',
                        'content': 'You are a helpful web assistant that helps users answer questions about the world based on the information provided to you by Google\'s search API. Answer the questions as truthfully as you can. In case you are unsure about the correct answer, please respond with "I apologize but I\'m not sure."',
                    },
                    {
                        'role': 'user',
                        'content': 'what\'s the temperature in Iceland?\n\n\n--Google search API results below:---\n\n"snippet":"2 Week Extended Forecast in Reykjavik, Iceland ; Feb 4, 29 / 20 °F · Snow showers early. Broken clouds. ; Feb 5, 27 / 16 °F · Light snow. Decreasing cloudiness.","snippet_highlighted_words":["Feb 4, 29 / 20 °F"]',
                    },
                ],
                ground_truth={
                    'role': 'assistant',
                    'content': 'The temperature in Reykjavik, Iceland is currently around 5F or -15C. Please note that weather conditions can change rapidly, so it\'s best to check a reliable source for the most up-to-date information.',
                },
                linked_event='6bba5182-d4b1-4b29-a64a-f0a8bd964f76',
                linked_datasets=[
                    '<value>',
                ],
                metadata={
                    'question_type': 'weather',
                    'completion_tokens': 47,
                    'prompt_tokens': 696,
                    'total_tokens': 743,
                },
            ))


            if res.object is not None:
                # handle response
                pass
        - lang: typescript
          label: createDatapoint
          source: |-
            import { HoneyHive } from "honeyhive";

            async function run() {
              const sdk = new HoneyHive({
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
              });

              const res = await sdk.datapoints.createDatapoint({
                project: "New Project",
                inputs: {
                  "query": "what's the temperature in Iceland?",
                },
                history: [
                  {
                    "role": "system",
                    "content": "You are a helpful web assistant that helps users answer questions about the world based on the information provided to you by Google's search API. Answer the questions as truthfully as you can. In case you are unsure about the correct answer, please respond with \"I apologize but I'm not sure.\"",
                  },
                  {
                    "role": "user",
                    "content": "what's the temperature in Iceland?\n\n\n--Google search API results below:---\n\n\"snippet\":\"2 Week Extended Forecast in Reykjavik, Iceland ; Feb 4, 29 / 20 °F · Snow showers early. Broken clouds. ; Feb 5, 27 / 16 °F · Light snow. Decreasing cloudiness.\",\"snippet_highlighted_words\":[\"Feb 4, 29 / 20 °F\"]",
                  },
                ],
                groundTruth: {
                  "role": "assistant",
                  "content": "The temperature in Reykjavik, Iceland is currently around 5F or -15C. Please note that weather conditions can change rapidly, so it's best to check a reliable source for the most up-to-date information.",
                },
                linkedEvent: "6bba5182-d4b1-4b29-a64a-f0a8bd964f76",
                linkedDatasets: [
                  "<value>",
                ],
                metadata: {
                  "question_type": "weather",
                  "completion_tokens": 47,
                  "prompt_tokens": 696,
                  "total_tokens": 743,
                },
              });

              if (res.statusCode == 200) {
                // handle response
              }
            }

            run();
components:
  schemas:
    CreateDatapointRequest:
      type: object
      properties:
        project:
          type: string
          description: Name for the project to which the datapoint belongs
        inputs:
          type: object
          description: Arbitrary JSON object containing the inputs for the datapoint
          additionalProperties: true
        history:
          type: array
          items:
            type: object
            additionalProperties: true
          description: Conversation history associated with the datapoint
        ground_truth:
          type: object
          additionalProperties: true
          description: Expected output JSON object for the datapoint
        linked_event:
          type: string
          description: Event id for the event from which the datapoint was created
        linked_datasets:
          type: array
          items:
            type: string
          description: Ids of all datasets that include the datapoint
        metadata:
          type: object
          additionalProperties: true
          description: Any additional metadata for the datapoint
      required:
        - project
        - inputs
      example:
        project: New Project
        inputs:
          query: what's the temperature in Iceland?
        history:
          - role: system
            content: >-
              You are a helpful web assistant that helps users answer questions
              about the world based on the information provided to you by
              Google's search API. Answer the questions as truthfully as you
              can. In case you are unsure about the correct answer, please
              respond with "I apologize but I'm not sure."
          - role: user
            content: >-
              what's the temperature in Iceland?\n\n\n--Google search API
              results below:---\n\n"snippet":"2 Week Extended Forecast in
              Reykjavik, Iceland ; Feb 4, 29 / 20 °F · Snow showers early.
              Broken clouds. ; Feb 5, 27 / 16 °F · Light snow. Decreasing
              cloudiness.","snippet_highlighted_words":["Feb 4, 29 / 20 °F"]
        ground_truth:
          role: assistant
          content: >-
            The temperature in Reykjavik, Iceland is currently around 5F or
            -15C. Please note that weather conditions can change rapidly, so
            it's best to check a reliable source for the most up-to-date
            information.
        linked_event: 6bba5182-d4b1-4b29-a64a-f0a8bd964f76
        linked_datasets: []
        metadata:
          question_type: weather
          completion_tokens: 47
          prompt_tokens: 696
          total_tokens: 743
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer

````